;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro patch_noi_table_event, event
  common table, param, orig
  
  WIDGET_CONTROL, event.id, GET_UVALUE=uvalue
  WIDGET_CONTROL, event.top, GET_UVALUE=id
  case uvalue of
     'edit': begin
        widget_control, id.table, get_value=dummy
        if dummy[event.x,event.y] LE 0 then begin
           a=dialog_message("Insert positive (>0) values!", /ERROR)
        endif
        dummy=rotate(dummy,7)
        *param.tab_iter=dummy
     end
     'reset': begin
        (*param.tab_iter)[*]=orig[*]
        dummy=orig
        dummy=reform(dummy,param.cols,param.rows)
        dummy=rotate(dummy,7)
        widget_control, id.table, set_value=dummy
     end
     'ok'   : begin
        WIDGET_CONTROL, event.top, /DESTROY
     end
     
  endcase
  
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function patch_noi_table, par, GROUP_LEADER=group
  
  common table, param, orig
  param=par
  orig=(*par.tab_iter)[*]
;param is the structure (of the parameters) containing edited/modified values
;orig is the structure containing original values
  
  id = { $       
       root_base_id0   : 0L, $
       table:0L $
       }
  param=par
  
  modal = n_elements(group) ne 0
  root_base_id0 = widget_base(TITLE="Number of Iterations (Noi) Table",/COL, $ 
                              modal=modal, GROUP_LEADER=group)
  base = widget_base(root_base_id0, /FRAME,/COL)
  
  tab_val=make_array(par.cols,par.rows,/LONG)
  ;help, tab_val
  for k=0, par.cols*par.rows-1 do begin
     tab_val[k mod par.cols,k/par.cols]=(*param.tab_iter)[k]
  endfor
  tab_val=rotate(tab_val,7)
  id.table= WIDGET_TABLE(base, value=tab_val,$
                                ; COLUMN_LABELS=["Left","Right"], $
                                ; ROW_LABELS=["Top","Bottom"], $
                         /EDITABLE, uvalue="edit", /NO_HEADERS, $
                         COLUMN_WIDTH=40, ROW_HEIGHTS=27, $
                         scr_xsize=400, scr_ysize=300)
  
  
  
; standard buttons base
  btn_base_id = widget_base(root_base_id0,/FRAME,/ROW, /ALIGN_RIGHT)
  reset_id = widget_button(btn_base_id,                               $
                           VALUE="Reset to default settings", $
                           UVALUE="reset"                                )
  
  ok_id = widget_button(btn_base_id,                               $
                        VALUE=" Save and close ", $
                        UVALUE="ok"                                )
  
  
  
  WIDGET_CONTROL, root_base_id0, SET_UVALUE=id
  WIDGET_CONTROL, root_base_id0, /REALIZE
  xmanager, 'patch_noi_table', root_base_id0, /NO_BLOCK, GROUP_LEADER=group
  return, param
  
end
