;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro patch_set_gui, state
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

if state.par.psf_type EQ 0 then begin
   value=["The file dimensions must be NxMxP, where P is the",$
          "number of sub-domains. The PSFs must be ordered  ",$
          "from 0 to P-1, as shown in the image.           ", $
          " "]
endif else begin
   value=["The files (one for each sub-domain) must have a  ",$
         "common prefix, followed by a number indicating the",$
         "corresponding sub-domain. E.g. (16 sub-domains):  ",$
         "'psf_00.fits', 'psf_01.fits', ..., 'psf_15.fits'    "]
endelse
widget_control, state.id.text, set_value=value
WIDGET_CONTROL, state.id.method, SET_COMBOBOX_SELECT=state.par.method


if state.par.bg_choice EQ 0 then begin
   widget_control, state.id.bg, /SENSITIVE
   widget_control, state.id.bg_file, SENSITIVE=0
   widget_control, state.id.bg_info, SET_VALUE=strarr(4)
endif else begin
   widget_control, state.id.bg, SENSITIVE=0
   widget_control, state.id.bg_file, /SENSITIVE
endelse


case state.par.method of
0: begin    ;RL parameters
   widget_control, state.id.stop_crit, SET_VALUE=['iter > MAX ITER']
   widget_control, state.id.stop_crit, SET_COMBOBOX_SELECT=state.par.stop_crit<0
   ;force stop_crit = 0
   state.par.stop_crit = 0
   end
1: begin    ;SGP parameters
   widget_control, state.id.stop_crit, SET_VALUE=['iter > MAX ITER', $
                                                  'distance of successive iterations', $
                                                  'data-fidelity function', $
                                                  'discrepancy principle']
   widget_control, state.id.stop_crit, SET_COMBOBOX_SELECT=state.par.stop_crit<3
   end
endcase

if state.par.stop_crit GT 0 then widget_control, state.id.tol, /SENSITIVE else $
                                 widget_control, state.id.tol, SENSITIVE=0

case state.par.mask_choice of
   0: begin
       widget_control, state.id.mask_filename, SENSITIVE=0
       widget_control, state.id.mask_info, SENSITIVE=0
    end
   1: begin
       widget_control, state.id.mask_filename, /SENSITIVE
       widget_control, state.id.mask_info, /SENSITIVE
    end
endcase

case state.par.it_choice of
   0: begin 
      widget_control, state.id.tot_iter, /SENSITIVE
      widget_control, state.id.it4, SENSITIVE=0
   end
   1: begin 
      widget_control, state.id.tot_iter, SENSITIVE=0
      widget_control, state.id.it4, /SENSITIVE
      if state.par.cols*state.par.rows LT 4 then begin
         a=dialog_message("At least 4 sub-domains are required!", /ERROR)
      endif
   end
   2: begin 
      widget_control, state.id.tot_iter, SENSITIVE=0
      widget_control, state.id.it4, SENSITIVE=0
   end
endcase



end
